=begin

JF North Angle Slider

Adjust the North Angle using an HTML range slider.

Author: Jim Foltz <jim.foltz@gmail.com>

History:

  * 2016-09-25.1 - Initial Release

  * 2016-09-26.1 
    - Added Shadow Display Toggle button

=end

module JF
   module NorthAngleSlider

      menu = defined?(JF.menu) ? JF.menu : UI.menu("Plugins")
      menu.add_item("JF North Angle Slider") { show_north_angle_slider() }

      def self.show_north_angle_slider()

         @dlg = UI::WebDialog.new("JF North Angle Slider", false, 'JF\North_Angle_Slider', 500, 250)

         html =
            '<DOCTYPE html>
            <html>
            <head>
            <style>
            * { font-family: sans-serif;}
            </style>
            <script>
               function slider_update(val) {
                  // var s = document.getElementById("txt");
                  txt.innerHTML=val;
                  window.location.href="skp:slider_updated@"+val;
               }
               function checkbox_update(b) {
                  window.location.href="skp:checkbox_updated@"+b;
               }
               function update_ui(val, st) {
                  txt.innerHTML = val;
                  north_angle.value = val;
                  document.getElementById("shadows").checked =  (st === "true");
                  // cb.setAttribute("checked", st);
               }
            </script>
            </head><body>
            <label>
            Display Shadows? <input id=shadows type=checkbox onchange="checkbox_update(this.checked)" />
            </label>
            <input id=north_angle name=north_angle type=range min=0 max=360 step=5 onchange="slider_update(this.value)"/>
            <span id=txt></span>
            </body></html>'

         @dlg.set_html(html)


         @dlg.add_action_callback("slider_updated") {|d, a|
            Sketchup.active_model.shadow_info["NorthAngle"] = a.to_i
         }

         @dlg.add_action_callback("checkbox_updated") {|d, a|
            Sketchup.active_model.shadow_info["DisplayShadows"] = (a  == "true")
         }

         @dlg.set_on_close{
            Sketchup.active_model.shadow_info["DisplayNorth"] = false
         }



         @dlg.show{
            si = Sketchup.active_model.shadow_info
            si["DisplayNorth"] = true
            UI.start_timer(0.2, false) {
               scr = "update_ui('" + (si['NorthAngle'].to_i).to_s + "', '" + si['DisplayShadows'].to_s + "')"
               @dlg.execute_script(scr)
            }
         }
      end

   end
end
